package curve

import (
	"context"
	"math/big"
	"testing"
	"time"

	"git.ali33.ru/fcg-xvii/curve/v2/tools"
)

func TestCurveInit(t *testing.T) {
	ctx, _ := context.WithDeadline(context.Background(), time.Now().Add(time.Second*30))
	curve, err := NewCurve(
		big.NewInt(2),
		big.NewInt(4),
		tools.Exp64(big.NewInt(2), 20),
		ctx,
	)
	if err != nil {
		t.Fatal(err)
	}
	curve.Map().LogPretty()
}
